/*
 * Start of am-utils-6.x config.h file.
 * Erez Zadok <ezk@cs.columbia.edu>
 *
 * DO NOT EDIT BY HAND.
 */

#ifndef _CONFIG_H
#define _CONFIG_H


/*
 * Check for types of amd filesystems available.
 */
/* Define if have automount filesystem */
#undef HAVE_AM_FS_AFS

/* Define if have direct automount filesystem */
#undef HAVE_AM_FS_DFS

/* Define if have "top-level" filesystem */
#undef HAVE_AM_FS_TOPLVL

/* Define if have error filesystem */
#undef HAVE_AM_FS_EFS

/* Define if have inheritance filesystem */
#undef HAVE_AM_FS_IFS

/* Define if have program filesystem */
#undef HAVE_AM_FS_PFS

/* Define if have symbolic-link filesystem */
#undef HAVE_AM_FS_SFS

/* Define if have symlink with exitence check filesystem */
#undef HAVE_AM_FS_SFSX

/* Define if have NFS host-tree filesystem */
#undef HAVE_AM_FS_HOST

/* Define if have multi-NFS filesystem */
#undef HAVE_AM_FS_NFSX

/* Define if have union filesystem */
#undef HAVE_AM_FS_UNION


/*
 * Check for types of maps available.
 */

/* Define if have file maps (everyone should have it!) */
#undef HAVE_MAP_FILE

/* Define if have NIS maps */
#undef HAVE_MAP_NIS

/* Define if have NIS+ maps */
#undef HAVE_MAP_NISPLUS

/* Define if have DBM maps */
#undef HAVE_MAP_DBM

/* Define if have NDBM maps */
#undef HAVE_MAP_NDBM

/* Define if have HESIOD maps */
#undef HAVE_MAP_HESIOD

/* Define if have PASSWD maps */
#undef HAVE_MAP_PASSWD

/* Define if have UNION maps */
#undef HAVE_MAP_UNION

/*
 * Check for filesystem types available.
 */

/* Define if have UFS filesystem */
#undef HAVE_FS_UFS

/* Define if have NFS filesystem */
#undef HAVE_FS_NFS

/* Define if have NFS3 filesystem */
#undef HAVE_FS_NFS3

/* Define if have PCFS filesystem */
#undef HAVE_FS_PCFS

/* Define if have LOFS filesystem */
#undef HAVE_FS_LOFS

/* Define if have HSFS filesystem */
#undef HAVE_FS_HSFS

/* Define if have CDFS filesystem */
#undef HAVE_FS_CDFS

/* Define if have TFS filesystem */
#undef HAVE_FS_TFS

/* Define if have TMPFS filesystem */
#undef HAVE_FS_TMPFS

/* Define if have MFS filesystem */
#undef HAVE_FS_MFS

/* Define if have CFS (crypto) filesystem */
#undef HAVE_FS_CFS

/* Define if have AUTOFS filesystem */
#undef HAVE_FS_AUTOFS

/* Define if have CACHEFS filesystem */
#undef HAVE_FS_CACHEFS

/*
 * Check for the type of the mount(2) system name for a filesystem.
 * Normally this is "nfs" (e.g. Solaris) or an integer (older systems)
 */

/* Mount(2) type/name for UFS filesystem */
#undef MOUNT_TYPE_UFS

/* Mount(2) type/name for NFS filesystem */
#undef MOUNT_TYPE_NFS

/* Mount(2) type/name for NFS3 filesystem */
#undef MOUNT_TYPE_NFS3

/* Mount(2) type/name for PCFS filesystem */
#undef MOUNT_TYPE_PCFS

/* Mount(2) type/name for LOFS filesystem */
#undef MOUNT_TYPE_LOFS

/* Mount(2) type/name for CDFS filesystem */
#undef MOUNT_TYPE_CDFS

/* Mount(2) type/name for TFS filesystem */
#undef MOUNT_TYPE_TFS

/* Mount(2) type/name for TMPFS filesystem */
#undef MOUNT_TYPE_TMPFS

/* Mount(2) type/name for MFS filesystem */
#undef MOUNT_TYPE_MFS

/* Mount(2) type/name for CFS (crypto) filesystem */
#undef MOUNT_TYPE_CFS

/* Mount(2) type/name for AUTOFS filesystem */
#undef MOUNT_TYPE_AUTOFS

/* Mount(2) type/name for CACHEFS filesystem */
#undef MOUNT_TYPE_CACHEFS

/* Mount(2) type/name for IGNORE filesystem (not real just ignore for df) */
#undef MOUNT_TYPE_IGNORE

/*
 * Check for the string name for the mount-table of a filesystem.
 */

/* Mount-table entry name for UFS filesystem */
#undef MNTTAB_TYPE_UFS

/* Mount-table entry name for NFS filesystem */
#undef MNTTAB_TYPE_NFS

/* Mount-table entry name for NFS3 filesystem */
#undef MNTTAB_TYPE_NFS3

/* Mount-table entry name for PCFS filesystem */
#undef MNTTAB_TYPE_PCFS

/* Mount-table entry name for LOFS filesystem */
#undef MNTTAB_TYPE_LOFS

/* Mount-table entry name for CDFS filesystem */
#undef MNTTAB_TYPE_CDFS

/* Mount-table entry name for TFS filesystem */
#undef MNTTAB_TYPE_TFS

/* Mount-table entry name for TMPFS filesystem */
#undef MNTTAB_TYPE_TMPFS

/* Mount-table entry name for MFS filesystem */
#undef MNTTAB_TYPE_MFS

/* Mount-table entry name for CFS (crypto) filesystem */
#undef MNTTAB_TYPE_CFS

/* Mount-table entry name for AUTOFS filesystem */
#undef MNTTAB_TYPE_AUTOFS

/* Mount-table entry name for CACHEFS filesystem */
#undef MNTTAB_TYPE_CACHEFS

/*
 * Name of mount table file name.
 */
#undef MNTTAB_FILE_NAME

/*
 * Names of various mount table option strings.
 */

/* Mount Table option string: Read only */
#undef MNTTAB_OPT_RO

/* Mount Table option string: Read/write */
#undef MNTTAB_OPT_RW

/* Mount Table option string: Read/write with quotas */
#undef MNTTAB_OPT_RQ

/* Mount Table option string: Check quotas */
#undef MNTTAB_OPT_QUOTA

/* Mount Table option string: Don't check quotas */
#undef MNTTAB_OPT_NOQUOTA

/* Mount Table option string: action to taken on error */
#undef MNTTAB_OPT_ONERROR

/* Mount Table option string: min. time between inconsistencies */
#undef MNTTAB_OPT_TOOSOON

/* Mount Table option string: Soft mount */
#undef MNTTAB_OPT_SOFT

/* Mount Table option string: spongy mount */
#undef MNTTAB_OPT_SPONGY

/* Mount Table option string: Hard mount */
#undef MNTTAB_OPT_HARD

/* Mount Table option string: Set uid allowed */
#undef MNTTAB_OPT_SUID

/* Mount Table option string: Set uid not allowed */
#undef MNTTAB_OPT_NOSUID

/* Mount Table option string: SysV-compatible gid on create */
#undef MNTTAB_OPT_GRPID

/* Mount Table option string: Change mount options */
#undef MNTTAB_OPT_REMOUNT

/* Mount Table option string: Disallow mounts on subdirs */
#undef MNTTAB_OPT_NOSUB

/* Mount Table option string: Do multi-component lookup */
#undef MNTTAB_OPT_MULTI

/* Mount Table option string: Allow NFS ops to be interrupted */
#undef MNTTAB_OPT_INTR

/* Mount Table option string: Don't allow interrupted ops */
#undef MNTTAB_OPT_NOINTR

/* Mount Table option string: NFS server IP port number */
#undef MNTTAB_OPT_PORT

/* Mount Table option string: Secure (AUTH_DES) mounting */
#undef MNTTAB_OPT_SECURE

/* Mount Table option string: Secure (AUTH_Kerb) mounting */
#undef MNTTAB_OPT_KERB

/* Mount Table option string: Max NFS read size (bytes) */
#undef MNTTAB_OPT_RSIZE

/* Mount Table option string: Max NFS write size (bytes) */
#undef MNTTAB_OPT_WSIZE

/* Mount Table option string: NFS timeout (1/10 sec) */
#undef MNTTAB_OPT_TIMEO

/* Mount Table option string: Max retransmissions (soft mnts) */
#undef MNTTAB_OPT_RETRANS

/* Mount Table option string: Attr cache timeout (sec) */
#undef MNTTAB_OPT_ACTIMEO

/* Mount Table option string: Min attr cache timeout (files) */
#undef MNTTAB_OPT_ACREGMIN

/* Mount Table option string: Max attr cache timeout (files) */
#undef MNTTAB_OPT_ACREGMAX

/* Mount Table option string: Min attr cache timeout (dirs) */
#undef MNTTAB_OPT_ACDIRMIN

/* Mount Table option string: Max attr cache timeout (dirs) */
#undef MNTTAB_OPT_ACDIRMAX

/* Mount Table option string: Don't cache attributes at all */
#undef MNTTAB_OPT_NOAC

/* Mount Table option string: No close-to-open consistency */
#undef MNTTAB_OPT_NOCTO

/* Mount Table option string: Do mount retries in background */
#undef MNTTAB_OPT_BG

/* Mount Table option string: Do mount retries in foreground */
#undef MNTTAB_OPT_FG

/* Mount Table option string: Number of mount retries */
#undef MNTTAB_OPT_RETRY

/* Mount Table option string: Device id of mounted fs */
#undef MNTTAB_OPT_DEV

/* Mount Table option string: Filesystem id of mounted fs */
#undef MNTTAB_OPT_FSID

/* Mount Table option string: Get static pathconf for mount */
#undef MNTTAB_OPT_POSIX

/* Mount Table option string: Automount map */
#undef MNTTAB_OPT_MAP

/* Mount Table option string: Automount   direct map mount */
#undef MNTTAB_OPT_DIRECT

/* Mount Table option string: Automount indirect map mount */
#undef MNTTAB_OPT_INDIRECT

/* Mount Table option string: Local locking (no lock manager) */
#undef MNTTAB_OPT_LLOCK

/* Mount Table option string: Ignore this entry */
#undef MNTTAB_OPT_IGNORE

/* Mount Table option string: No auto (what?) */
#undef MNTTAB_OPT_NOAUTO

/* Mount Table option string: No connection */
#undef MNTTAB_OPT_NOCONN

/* Mount Table option string: protocol version number indicator */
#undef MNTTAB_OPT_VERS

/* Mount Table option string: protocol network_id indicator */
#undef MNTTAB_OPT_PROTO

/* Mount Table option string: Synchronous local directory ops */
#undef MNTTAB_OPT_SYNCDIR

/* Mount Table option string: Do no allow setting sec attrs */
#undef MNTTAB_OPT_NOSETSEC

/* Mount Table option string: set symlink cache time-to-live */
#undef MNTTAB_OPT_SYMTTL

/* Mount Table option string: compress */
#undef MNTTAB_OPT_COMPRESS

/* Mount Table option string: pg thresh(old)? */
#undef MNTTAB_OPT_PGTHRESH


/*
 * Generic mount(2) options (hex numbers)
 */

/* asynchronous filesystem access */
#undef MNT2_GEN_OPT_ASYNC

/* cache (what?) */
#undef MNT2_GEN_OPT_CACHE

/* 6-argument mount */
#undef MNT2_GEN_OPT_DATA

/* Old (4-argument) mount (compatibility) */
#undef MNT2_GEN_OPT_FSS

/* Old BSD group-id on create */
#undef MNT2_GEN_OPT_GRPID

/* Do multi-component lookup on files */
#undef MNT2_GEN_OPT_MULTI

/* use type string instead of int */
#undef MNT2_GEN_OPT_NEWTYPE

/* NFS mount */
#undef MNT2_GEN_OPT_NFS

/* nocache (what?) */
#undef MNT2_GEN_OPT_NOCACHE

/* not a device */
#undef MNT2_GEN_OPT_NODEV

/* no exec calls allowed */
#undef MNT2_GEN_OPT_NOEXEC

/* not a device  */
#undef MNT2_GEN_OPT_NONDEV

/* Disallow mounts beneath this mount */
#undef MNT2_GEN_OPT_NOSUB

/* Setuid programs disallowed */
#undef MNT2_GEN_OPT_NOSUID

/* Return ENAMETOOLONG for long filenames */
#undef MNT2_GEN_OPT_NOTRUNC

/* allow overlay mounts */
#undef MNT2_GEN_OPT_OVERLAY

/* Read-only */
#undef MNT2_GEN_OPT_RDONLY

/* change options on an existing mount */
#undef MNT2_GEN_OPT_REMOUNT

/* read only */
#undef MNT2_GEN_OPT_RONLY

/* synchronize data immediately to filesystem */
#undef MNT2_GEN_OPT_SYNC

/* synchronous filesystem access (same as SYNC) */
#undef MNT2_GEN_OPT_SYNCHRONOUS

/* Mount with Sys 5-specific semantics */
#undef MNT2_GEN_OPT_SYS5

/* Union mount */
#undef MNT2_GEN_OPT_UNION

/*
 * NFS-specific mount(2) options (hex numbers)
 */

/* set max secs for dir attr cache */
#undef MNT2_NFS_OPT_ACDIRMAX

/* set min secs for dir attr cache */
#undef MNT2_NFS_OPT_ACDIRMIN

/* set max secs for file attr cache */
#undef MNT2_NFS_OPT_ACREGMAX

/* set min secs for file attr cache */
#undef MNT2_NFS_OPT_ACREGMIN

/* Authentication error */
#undef MNT2_NFS_OPT_AUTHERR

/* set dead server retry thresh */
#undef MNT2_NFS_OPT_DEADTHRESH

/* Dismount in progress */
#undef MNT2_NFS_OPT_DISMINPROG

/* Dismounted */
#undef MNT2_NFS_OPT_DISMNT

/* Don't estimate rtt dynamically */
#undef MNT2_NFS_OPT_DUMBTIMR

/* System V-style gid inheritance */
#undef MNT2_NFS_OPT_GRPID

/* Has authenticator */
#undef MNT2_NFS_OPT_HASAUTH

/* set hostname for error printf */
#undef MNT2_NFS_OPT_HOSTNAME

/* allow interrupts on hard mount */
#undef MNT2_NFS_OPT_INT

/* Bits set internally */
#undef MNT2_NFS_OPT_INTERNAL

/* Use Kerberos authentication */
#undef MNT2_NFS_OPT_KERB

/* use kerberos credentials */
#undef MNT2_NFS_OPT_KERBEROS

/* transport's knetconfig structure */
#undef MNT2_NFS_OPT_KNCONF

/* set lease term (nqnfs) */
#undef MNT2_NFS_OPT_LEASETERM

/* Local locking (no lock manager) */
#undef MNT2_NFS_OPT_LLOCK

/* set maximum grouplist size */
#undef MNT2_NFS_OPT_MAXGRPS

/* Mnt server for mnt point */
#undef MNT2_NFS_OPT_MNTD

/* Assume writes were mine */
#undef MNT2_NFS_OPT_MYWRITE

/* don't cache attributes */
#undef MNT2_NFS_OPT_NOAC

/* Don't Connect the socket */
#undef MNT2_NFS_OPT_NOCONN

/* no close-to-open consistency */
#undef MNT2_NFS_OPT_NOCTO

/* disallow interrupts on hard mounts */
#undef MNT2_NFS_OPT_NOINT

/* Get lease for lookup */
#undef MNT2_NFS_OPT_NQLOOKLEASE

/* Use Nqnfs protocol */
#undef MNT2_NFS_OPT_NQNFS

/* static pathconf kludge info */
#undef MNT2_NFS_OPT_POSIX

/* Rcv socket lock */
#undef MNT2_NFS_OPT_RCVLOCK

/* Do lookup with readdir (nqnfs) */
#undef MNT2_NFS_OPT_RDIRALOOK

/* set read ahead */
#undef MNT2_NFS_OPT_READAHEAD

/* Allocate a reserved port */
#undef MNT2_NFS_OPT_RESVPORT

/* set number of request retrys */
#undef MNT2_NFS_OPT_RETRANS

/* use RPC to do secure NFS time sync */
#undef MNT2_NFS_OPT_RPCTIMESYNC

/* set read size */
#undef MNT2_NFS_OPT_RSIZE

/* secure mount */
#undef MNT2_NFS_OPT_SECURE

/* Send socket lock */
#undef MNT2_NFS_OPT_SNDLOCK

/* soft mount (hard is default) */
#undef MNT2_NFS_OPT_SOFT

/* spongy mount */
#undef MNT2_NFS_OPT_SPONGY

/* set initial timeout */
#undef MNT2_NFS_OPT_TIMEO

/* Wait for authentication */
#undef MNT2_NFS_OPT_WAITAUTH

/* Wants an authenticator */
#undef MNT2_NFS_OPT_WANTAUTH

/* Want receive socket lock */
#undef MNT2_NFS_OPT_WANTRCV

/* Want send socket lock */
#undef MNT2_NFS_OPT_WANTSND

/* set write size */
#undef MNT2_NFS_OPT_WSIZE

/* set symlink cache time-to-live */
#undef MNT2_NFS_OPT_SYMTTL

/* pg thresh(old) */
#undef MNT2_NFS_OPT_PGTHRESH

/*
 * Existence of fields in structures.
 */

/* does mntent_t have mnt_cnode field? */
#undef HAVE_FIELD_MNTENT_T_MNT_CNODE

/* does mntent_t have mnt_time field? */
#undef HAVE_FIELD_MNTENT_T_MNT_TIME

/* does mntent_t have mnt_time field and is of type "char *" ? */
#undef HAVE_FIELD_MNTENT_T_TIME_STRING

/* does mntent_t have mnt_ro field? */
#undef HAVE_FIELD_MNTENT_T_MNT_RO

/* does cdfs_args_t have norrip field? */
#undef HAVE_FIELD_CDFS_ARGS_T_NORRIP

/* does pcfs_args_t have fspec field? */
#undef HAVE_FIELD_PCFS_ARGS_T_FSPEC

/* does pcfs_args_t have secondswest field? */
#undef HAVE_FIELD_PCFS_ARGS_T_SECONDSWEST

/* does pcfs_args_t have dsttime field? */
#undef HAVE_FIELD_PCFS_ARGS_T_DSTTIME

/* does ufs_args_t have flags field? */
#undef HAVE_FIELD_UFS_ARGS_T_FLAGS

/* does ufs_args_t have fspec field? */
#undef HAVE_FIELD_UFS_ARGS_T_FSPEC

/* does struct fhstatus have an fhs_fh field? */
#undef HAVE_FIELD_STRUCT_FHSTATUS_FHS_FH

/**************************************************************************/
/*** Everything above this line is part of the "TOP" of acconfig.h.	***/
/**************************************************************************/

@TOP@

/**************************************************************************/
/*** Everything below this line is above "BOTTOM" and right below "TOP" ***/
/**************************************************************************/

/* Turn off general debugging by default */
#undef DEBUG

/* Turn off memory debugging by default */
#undef DEBUG_MEM

/* Turn on selectors in /default map entries by default */
#undef ENABLE_DEFAULT_SELECTORS

/* Define package name (must be defined by configure.in) */
#undef PACKAGE

/* Define version of package (must be defined by configure.in) */
#undef VERSION

/* Define name of host machine's cpu (eg. sparc) */
#undef HOST_CPU

/* Define name of host machine's architecture (eg. sun4) */
#undef HOST_ARCH

/* Define name of host machine's vendor (eg. sun) */
#undef HOST_VENDOR

/* Define name and version of host machine (eg. solaris2.5.1) */
#undef HOST_OS

/* Define only name of host machine OS (eg. solaris2) */
#undef HOST_OS_NAME

/* Define only version of host machine (eg. 2.5.1) */
#undef HOST_OS_VERSION


/* what type of network transport type is in use?  TLI or sockets? */
#undef HAVE_TRANSPORT_TYPE_TLI

/* Define to `long' if <sys/types.h> doesn't define time_t */
#undef time_t

/* Define to "void *" if compiler can handle, otherwise "char *" */
#undef voidp

/* Define a type/structure for an nfs filehandle */
/* unnecessary test, as struct nfs_fh is defined by <rpcsvc/nfs_prot.h> */
#undef nfs_fh

/* Define a type for the nfs_args structure */
#undef nfs_args_t

/* Define the field name for the filehandle within nfs_args_t */
#undef NFS_FH_FIELD

/* Define if plain fhandle type exists */
#undef HAVE_FHANDLE

/* Define the type of the 3rd argument ('in') to svc_getargs() */
#undef SVC_IN_ARG_TYPE

/* Define to the type of xdr procedure type */
#undef XDRPROC_T_TYPE

/* Define if mount table is on file, undefine if in kernel */
#undef MOUNT_TABLE_ON_FILE

/* Define if have struct mntent in one of the standard headers */
#undef HAVE_STRUCT_MNTENT

/* Define if have struct mnttab in one of the standard headers */
#undef HAVE_STRUCT_MNTTAB

/* Define if have struct nfs_args in one of the standard nfs headers */
#undef HAVE_STRUCT_NFS_ARGS

/* Define if have struct nfs_mount_data in one of the standard nfs headers */
#undef HAVE_STRUCT_NFS_MOUNT_DATA

/* Define if have struct nfs_gfs_mount in one of the standard nfs headers */
#undef HAVE_STRUCT_NFS_GFS_MOUNT

/* Type of the mount-type field in the mount() system call */
#undef YP_ORDER_OUTORDER_TYPE

/* The string used in printf to print the mount-type field of mount(2) */
#undef MTYPE_PRINTF_TYPE

/* Type of the 3rd argument to yp_order() */
#undef MTYPE_TYPE

/* Define a type for the pcfs_args structure */
#undef pcfs_args_t

/* Define a type for the autofs_args structure */
#undef autofs_args_t

/* Define a type for the cachefs_args structure */
#undef cachefs_args_t

/* Define a type for the tmpfs_args structure */
#undef tmpfs_args_t

/* Define a type for the ufs_args structure */
#undef ufs_args_t

/* Define a type for the lofs_args structure */
#undef lofs_args_t

/* Define a type for the cdfs_args structure */
#undef cdfs_args_t

/* Define a type for the mfs_args structure */
#undef mfs_args_t

/* Define a type for the rfs_args structure */
#undef rfs_args_t

/*
 * Actions to take if ANSI C.
 */
#if STDC_HEADERS
# include <string.h>
/* for function prototypes */
# define P(x) x
# define P_void void
#else /* not STDC_HEADERS */
/* empty function prototypes */
# define P(x) ()
# define P_void
# ifndef HAVE_STRCHR
#  define strchr index
#  define strrchr rindex
# endif /* not HAVE_STRCHR */
char *strchr(), *strrchr(), *strdup();
#endif /* not STDC_HEADERS */

/*
 * How to handle signals of any type
 */
#ifdef HAVE_SYS_WAIT_H
# include <sys/wait.h>
#endif /* HAVE_SYS_WAIT_H */
#ifndef WEXITSTATUS
# define WEXITSTATUS(stat_val) ((unsigned)(stat_val) >> 8)
#endif /* not WEXITSTATUS */
#ifndef WIFEXITED
# define WIFEXITED(stat_val) (((stat_val) & 255) == 0)
#endif /* not WIFEXITED */

/*
 * Actions to take regarding <time.h> and <sys/time.h>.
 */
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else /* not TIME_WITH_SYS_TIME */
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else /* not HAVE_SYS_TIME_H */
#  include <time.h>
# endif /* not HAVE_SYS_TIME_H */
#endif /* not TIME_WITH_SYS_TIME */

/*
 * Actions to take if <machine/endian.h> exists.
 */
#ifdef HAVE_MACHINE_ENDIAN_H
# include <machine/endian.h>
#endif /* HAVE_MACHINE_ENDIAN_H */

/*
 * Big-endian or little-endian?
 */
#ifdef WORDS_BIGENDIAN
# define ARCH_ENDIAN "big"
#else /* not WORDS_BIGENDIAN */
# define ARCH_ENDIAN "little"
#endif /* not WORDS_BIGENDIAN */

/**************************************************************************/
/*** Everything below this line is right above "BOTTOM" but below "TOP" ***/
/**************************************************************************/

@BOTTOM@

/**************************************************************************/
/*** Everything below this line is part of the "BOTTOM" of acconfig.h.	***/
/**************************************************************************/

/*
 * Actions to take if HAVE_SYS_TYPES_H is defined.
 */
#if HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */

/*
 * Actions to take if HAVE_UNISTD_H is defined.
 */
#if HAVE_UNISTD_H
# include <unistd.h>
#endif /* HAVE_UNISTD_H */

/* after <unistd.h>, check if this is a POSIX.1 system */
#ifdef _POSIX_VERSION
/* Code for POSIX.1 systems. */
#endif /* _POSIX_VERSION */

/*
 * Variable length argument lists.
 * Use one of the two.
 */
#ifdef HAVE_STDARG_H
# include <stdarg.h>
#else /* not HAVE_STDARG_H */
# ifdef HAVE_VARARGS_H
#  include <varargs.h>
# endif /* HAVE_VARARGS_H */
#endif /* not HAVE_STDARG_H */

/*
 * Pick the right header file and macros for directory processing functions.
 */
#if HAVE_DIRENT_H
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)
#else /* not HAVE_DIRENT_H */
# define dirent direct
# define NAMLEN(dirent) (dirent)->d_namlen
# if HAVE_SYS_NDIR_H
#  include <sys/ndir.h>
# endif /* HAVE_SYS_NDIR_H */
# if HAVE_SYS_DIR_H
#  include <sys/dir.h>
# endif /* HAVE_SYS_DIR_H */
# if HAVE_NDIR_H
#  include <ndir.h>
# endif /* HAVE_NDIR_H */
#endif /* not HAVE_DIRENT_H */

/*
 * Actions to take if HAVE_FCNTL_H is defined.
 */
#if HAVE_FCNTL_H
# include <fcntl.h>
#endif /* HAVE_FCNTL_H */

/*
 * Actions to take if HAVE_MEMORY_H is defined.
 */
#if HAVE_MEMORY_H
# include <memory.h>
#endif /* HAVE_MEMORY_H */

/*
 * Actions to take if HAVE_SYS_FILE_H is defined.
 */
#if HAVE_SYS_FILE_H
# include <sys/file.h>
#endif /* HAVE_SYS_FILE_H */

/*
 * Actions to take if HAVE_SYS_IOCTL_H is defined.
 */
#if HAVE_SYS_IOCTL_H
# include <sys/ioctl.h>
#endif /* HAVE_SYS_IOCTL_H */

/*
 * Actions to take if HAVE_SYSLOG_H or HAVE_SYS_SYSLOG_H is defined.
 */
#ifdef HAVE_SYSLOG_H
# include <syslog.h>
#else /* not HAVE_SYSLOG_H */
# if HAVE_SYS_SYSLOG_H
#  include <sys/syslog.h>
# endif /* HAVE_SYS_SYSLOG_H */
#endif /* HAVE_SYSLOG_H */

/*
 * Actions to take if <sys/param.h> exists.
 */
#ifdef HAVE_SYS_PARAM_H
# include <sys/param.h>
#endif /* HAVE_SYS_PARAM_H */

/*
 * Actions to take if <sys/socket.h> exists.
 */
#ifdef HAVE_SYS_SOCKET_H
# include <sys/socket.h>
#endif /* HAVE_SYS_SOCKET_H */

/*
 * Actions to take if <rpc/rpc.h> exists.
 */
#ifdef HAVE_RPC_RPC_H
/*
 * Turn on PORTMAP, so that additional header files would get included
 * and the important definition for UDPMSGSIZE is included too.
 */
# ifndef PORTMAP
#  define PORTMAP
# endif /* not PORTMAP */
# include <rpc/rpc.h>
# ifndef XDRPROC_T_TYPE
typedef bool_t (*xdrproc_t) __P ((XDR *, __ptr_t, ...));
# endif /* not XDRPROC_T_TYPE */
#endif /* HAVE_RPC_RPC_H */

/*
 * Actions to take if <rpc/types.h> exists.
 */
#ifdef HAVE_RPC_TYPES_H
# include <rpc/types.h>
#endif /* HAVE_RPC_TYPES_H */

/*
 * Actions to take if <rpc/auth.h> exists.
 */
#ifdef HAVE_RPC_AUTH_H
/*
 * Make sure external definition for xdr_opaque_auth exists.  One way to do
 * so is to temporarily define _KERNEL here.  But that is not possible,
 * because <rpc/auth.h> is included before via <rpc/rpc.h>, so I will try
 * and include this before.  No!  That did not work either.  It creates a
 * conflicting external declaration of NOERROR (with <arpa/nameser.h>), so I
 * can only define that extern here.
 */
# include <rpc/auth.h>
extern bool_t xdr_opaque_auth(XDR *, struct opaque_auth *);
#endif /* HAVE_RPC_AUTH_H */

/*
 * Actions to take if <malloc.h> exists.
 */
#ifdef HAVE_MALLOC_H
# include <malloc.h>
#endif /* HAVE_MALLOC_H */

/*
 * Actions to take if <mntent.h> exists.
 */
#ifdef HAVE_MNTENT_H
/* some systems need <stdio.h> before <mntent.h> is included */
# ifdef HAVE_STDIO_H
#  include <stdio.h>
# endif /* HAVE_STDIO_H */
# include <mntent.h>
#endif /* HAVE_MNTENT_H */

/*
 * Actions to take if <sys/errno.h> exists.
 */
#ifdef HAVE_SYS_ERRNO_H
# include <sys/errno.h>
extern int errno;
#endif /* HAVE_SYS_ERRNO_H */

/*
 * Actions to take if <sys/mntent.h> exists.
 */
#ifdef HAVE_SYS_MNTENT_H
# include <sys/mntent.h>
#endif /* HAVE_SYS_MNTENT_H */

/*
 * Actions to take if <ndbm.h> exists.
 * Should be included before <rpcsvc/yp_prot.h> because on some systems
 * like Linux, it also defines "struct datum".
 */
#ifdef HAVE_NDBM_H
# include <ndbm.h>
# ifndef DATUM
/* ensure that struct datum is not included again from <rpcsvc/yp_prot.h> */
#  define DATUM
# endif /* not DATUM */
#endif /* HAVE_NDBM_H */

/*
 * Actions to take if <rpcsvc/yp_prot.h> exists.
 */
#ifdef HAVE_RPCSVC_YP_PROT_H
# include <rpcsvc/yp_prot.h>
#endif /* HAVE_RPCSVC_YP_PROT_H */

/*
 * Actions to take if <rpcsvc/ypclnt.h> exists.
 */
#ifdef HAVE_RPCSVC_YPCLNT_H
# include <rpcsvc/ypclnt.h>
#endif /* HAVE_RPCSVC_YPCLNT_H */

/*
 * NFS PROTOCOL HEADER FILES:
 */
/*
 * we include am-util's nfs_prot.h only if we don't expect other headers
 * to have the same definitions.
 */
#if !defined(HAVE_RPCSVC_NFS_PROT_H)
# ifdef HAVE_NFS_NFS_H
#  include <nfs/nfs.h>
# endif /* HAVE_NFS_NFS_H */
# ifdef HAVE_SYS_FS_NFS_H
#  include <sys/fs/nfs.h>
# endif /* HAVE_SYS_FS_NFS_H */
# ifdef HAVE_RPCSVC_MOUNT_H
#  include <rpcsvc/mount.h>
# endif /* HAVE_RPCSVC_MOUNT_H */
# include <amu_nfs_prot.h>
#endif /* !defined(HAVE_RPCSVC_NFS_PROT_H) */

#ifdef HAVE_RPCSVC_NFS_PROT_H
# include <rpcsvc/nfs_prot.h>
#endif /* HAVE_RPCSVC_NFS_PROT_H */
#ifdef HAVE_SYS_FS_NFS_H
# include <sys/fs/nfs.h>
#endif /* HAVE_SYS_FS_NFS_H */

/*
 * DO NOT INCLUDE THESE FILES:
 * They conflicts with other NFS headers and are generally not needed.
 */
#ifdef DO_NOT_INCLUDE
# ifdef HAVE_NFS_NFS_CLNT_H
#  include <nfs/nfs_clnt.h>
# endif /* HAVE_NFS_NFS_CLNT_H */
# ifdef HAVE_LINUX_NFS_H
#  include <linux/nfs.h>
# endif /* HAVE_LINUX_NFS_H */
# ifdef HAVE_NFS_NFSV2_H
#  include <nfs/nfsv2.h>
# endif /* HAVE_NFS_NFSV2_H */
#endif /* DO NOT INCLUDE */

/*
 * Actions to take if one of the nfs headers exists.
 */
#ifdef HAVE_NFS_NFS_GFS_H
# include <nfs/nfs_gfs.h>
#endif /* HAVE_NFS_NFS_GFS_H */
#ifdef HAVE_NFS_MOUNT_H
# include <nfs/mount.h>
#endif /* HAVE_NFS_MOUNT_H */
#ifdef HAVE_NFS_NFS_MOUNT_H
# include <nfs/nfs_mount.h>
#endif /* HAVE_NFS_NFS_MOUNT_H */
#ifdef HAVE_NFS_PATHCONF_H
# include <nfs/pathconf.h>
#endif /* HAVE_NFS_PATHCONF_H */
#ifdef HAVE_SYS_FS_NFS_MOUNT_H
# include <sys/fs/nfs/mount.h>
#endif /* HAVE_SYS_FS_NFS_MOUNT_H */
#ifdef HAVE_SYS_FS_NFS_NFS_CLNT_H
# include <sys/fs/nfs/nfs_clnt.h>
#endif /* HAVE_SYS_FS_NFS_NFS_CLNT_H */
#ifdef HAVE_SYS_FS_NFS_CLNT_H
# include <sys/fs/nfs_clnt.h>
#endif /* HAVE_SYS_FS_NFS_CLNT_H */
#ifdef HAVE_LINUX_NFS_MOUNT_H
# include <linux/nfs_mount.h>
#endif /* HAVE_LINUX_NFS_MOUNT_H */

/*
 * Actions to take if <pwd.h> exists.
 */
#ifdef HAVE_PWD_H
# include <pwd.h>
#endif /* HAVE_PWD_H */

/*
 * Actions to take if <hesiod.h> exists.
 */
#ifdef HAVE_HESIOD_H
# include <hesiod.h>
#endif /* HAVE_HESIOD_H */

/*
 * Actions to take if <arpa/nameser.h> exists.
 * Should be included before <resolv.h>.
 */
#ifdef HAVE_ARPA_NAMESER_H
# include <arpa/nameser.h>
#endif /* HAVE_ARPA_NAMESER_H */

/*
 * Actions to take if <resolv.h> exists.
 */
#ifdef HAVE_RESOLV_H
# include <resolv.h>
#endif /* HAVE_RESOLV_H */

/*
 * Actions to take if <sys/uio.h> exists.
 */
#ifdef HAVE_SYS_UIO_H
# include <sys/uio.h>
#endif /* HAVE_SYS_UIO_H */

/*
 * Actions to take if <sys/fs/autofs.h> exists.
 */
#ifdef HAVE_SYS_FS_AUTOFS_H
# include <sys/fs/autofs.h>
#endif /* HAVE_SYS_FS_AUTOFS_H */

/*
 * Actions to take if <sys/fs/cachefs_fs.h> exists.
 */
#ifdef HAVE_SYS_FS_CACHEFS_FS_H
# include <sys/fs/cachefs_fs.h>
#endif /* HAVE_SYS_FS_CACHEFS_FS_H */

/*
 * Actions to take if <sys/fs/pc_fs.h> exists.
 */
#ifdef HAVE_SYS_FS_PC_FS_H
# include <sys/fs/pc_fs.h>
#endif /* HAVE_SYS_FS_PC_FS_H */

/*
 * Actions to take if <sys/fs/tmp.h> exists.
 */
#ifdef HAVE_SYS_FS_TMP_H
# include <sys/fs/tmp.h>
#endif /* HAVE_SYS_FS_TMP_H */

/*
 * Actions to take if <sys/fs/ufs_mount.h> exists.
 */
#ifdef HAVE_SYS_FS_UFS_MOUNT_H
# include <sys/fs/ufs_mount.h>
#endif /* HAVE_SYS_FS_UFS_MOUNT_H */

/*
 * Actions to take if <sys/fs/efs_clnt.h> exists.
 */
#ifdef HAVE_SYS_FS_EFS_CLNT_H
# include <sys/fs/efs_clnt.h>
#endif /* HAVE_SYS_FS_EFS_CLNT_H */

/*
 * Actions to take if <assert.h> exists.
 */
#ifdef HAVE_ASSERT_H
# include <assert.h>
#endif /* HAVE_ASSERT_H */

/*
 * Actions to take if <cfs.h> exists.
 */
#ifdef HAVE_CFS_H
# include <cfs.h>
#endif /* HAVE_CFS_H */

/*
 * Actions to take if <cluster.h> exists.
 */
#ifdef HAVE_CLUSTER_H
# include <cluster.h>
#endif /* HAVE_CLUSTER_H */

/*
 * Actions to take if <ctype.h> exists.
 */
#ifdef HAVE_CTYPE_H
# include <ctype.h>
#endif /* HAVE_CTYPE_H */

/*
 * Actions to take if <errno.h> exists.
 */
#ifdef HAVE_ERRNO_H
# include <errno.h>
#endif /* HAVE_ERRNO_H */

/*
 * Actions to take if <grp.h> exists.
 */
#ifdef HAVE_GRP_H
# include <grp.h>
#endif /* HAVE_GRP_H */

/*
 * Actions to take if <hsfs/hsfs.h> exists.
 */
#ifdef HAVE_HSFS_HSFS_H
# include <hsfs/hsfs.h>
#endif /* HAVE_HSFS_HSFS_H */

/*
 * Actions to take if <mnttab.h> exists.
 */
#ifdef HAVE_MNTTAB_H
# include <mnttab.h>
#endif /* HAVE_MNTTAB_H */

/*
 * Actions to take if <mount.h> exists.
 */
#ifdef HAVE_MOUNT_H
# include <mount.h>
#endif /* HAVE_MOUNT_H */

/*
 * Actions to take if <net/errno.h> exists.
 */
#ifdef HAVE_NET_ERRNO_H
# include <net/errno.h>
#endif /* HAVE_NET_ERRNO_H */

/*
 * Actions to take if <net/if.h> exists.
 */
#ifdef HAVE_NET_IF_H
# include <net/if.h>
#endif /* HAVE_NET_IF_H */

/*
 * Actions to take if <netdb.h> exists.
 */
#ifdef HAVE_NETDB_H
# include <netdb.h>
#endif /* HAVE_NETDB_H */

/*
 * Actions to take if <netdir.h> exists.
 */
#ifdef HAVE_NETDIR_H
# include <netdir.h>
#endif /* HAVE_NETDIR_H */

/*
 * Actions to take if <netinet/if_ether.h> exists.
 */
#ifdef HAVE_NETINET_IF_ETHER_H
# include <netinet/if_ether.h>
#endif /* HAVE_NETINET_IF_ETHER_H */

/*
 * Actions to take if <netinet/in.h> exists.
 */
#ifdef HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif /* HAVE_NETINET_IN_H */

/*
 * Actions to take if <nsswitch.h> exists.
 */
#ifdef HAVE_NSSWITCH_H
# include <nsswitch.h>
#endif /* HAVE_NSSWITCH_H */

/*
 * Actions to take if <rpc/auth_des.h> exists.
 */
#ifdef HAVE_RPC_AUTH_DES_H
# include <rpc/auth_des.h>
#endif /* HAVE_RPC_AUTH_DES_H */

/*
 * Actions to take if <rpc/clnt.h> exists.
 *
 * Turn on PORTMAP, so that additional header files would get included
 * and the important definition for UDPMSGSIZE is included too.
 */
#ifndef PORTMAP
# define PORTMAP
#endif /* not PORTMAP */
#ifdef HAVE_RPC_CLNT_H
# include <rpc/clnt.h>
#endif /* HAVE_RPC_CLNT_H */

/*
 * Actions to take if <rpc/pmap_clnt.h> exists.
 */
#ifdef HAVE_RPC_PMAP_CLNT_H
# include <rpc/pmap_clnt.h>
#endif /* HAVE_RPC_PMAP_CLNT_H */

/*
 * Actions to take if <rpc/pmap_prot.h> exists.
 */
#ifdef HAVE_RPC_PMAP_PROT_H
# include <rpc/pmap_prot.h>
#endif /* HAVE_RPC_PMAP_PROT_H */

/*
 * Actions to take if <rpc/xdr.h> exists.
 */
#ifdef HAVE_RPC_XDR_H
# include <rpc/xdr.h>
#endif /* HAVE_RPC_XDR_H */

/*
 * Actions to take if <rpcsvc/mount.h> exists.
 */
#ifdef HAVE_RPCSVC_MOUNT_H
# include <rpcsvc/mount.h>
#endif /* HAVE_RPCSVC_MOUNT_H */

/*
 * Actions to take if <rpcsvc/nis.h> exists.
 */
#ifdef HAVE_RPCSVC_NIS_H
# include <rpcsvc/nis.h>
#endif /* HAVE_RPCSVC_NIS_H */

/*
 * Actions to take if <setjmp.h> exists.
 */
#ifdef HAVE_SETJMP_H
# include <setjmp.h>
#endif /* HAVE_SETJMP_H */

/*
 * Actions to take if <signal.h> exists.
 */
#ifdef HAVE_SIGNAL_H
# include <signal.h>
#endif /* HAVE_SIGNAL_H */

/*
 * Actions to take if <strings.h> exists.
 */
#ifdef HAVE_STRINGS_H
# include <strings.h>
#endif /* HAVE_STRINGS_H */

/*
 * Actions to take if <sys/config.h> exists.
 */
#ifdef HAVE_SYS_CONFIG_H
# include <sys/config.h>
#endif /* HAVE_SYS_CONFIG_H */

/*
 * Actions to take if <sys/dg_mount.h> exists.
 */
#ifdef HAVE_SYS_DG_MOUNT_H
# include <sys/dg_mount.h>
#endif /* HAVE_SYS_DG_MOUNT_H */

/*
 * Actions to take if <sys/fs_types.h> exists.
 */
#ifdef HAVE_SYS_FS_TYPES_H
# include <sys/fs_types.h>
#endif /* HAVE_SYS_FS_TYPES_H */

/*
 * Actions to take if <sys/fsid.h> exists.
 */
#ifdef HAVE_SYS_FSID_H
# include <sys/fsid.h>
#endif /* HAVE_SYS_FSID_H */

/*
 * Actions to take if <sys/fstyp.h> exists.
 */
#ifdef HAVE_SYS_FSTYP_H
# include <sys/fstyp.h>
#endif /* HAVE_SYS_FSTYP_H */

/*
 * Actions to take if <sys/lock.h> exists.
 */
#ifdef HAVE_SYS_LOCK_H
# include <sys/lock.h>
#endif /* HAVE_SYS_LOCK_H */

/*
 * Actions to take if <sys/machine.h> exists.
 */
#ifdef HAVE_SYS_MACHINE_H
# include <sys/machine.h>
#endif /* HAVE_SYS_MACHINE_H */

/*
 * Actions to take if <sys/mntctl.h> exists.
 */
#ifdef HAVE_SYS_MNTCTL_H
# include <sys/mntctl.h>
#endif /* HAVE_SYS_MNTCTL_H */

/*
 * Actions to take if <sys/mnttab.h> exists.
 */
#ifdef HAVE_SYS_MNTTAB_H
# include <sys/mnttab.h>
#endif /* HAVE_SYS_MNTTAB_H */

/*
 * Actions to take if <sys/mount.h> exists.
 */
#ifdef HAVE_SYS_MOUNT_H
/*
 * Some operating systems must define these variables to get
 * NFS and other definitions included.
 */
# ifndef NFSCLIENT
#  define NFSCLIENT
# endif /* not NFSCLIENT */
# ifndef NFS
#  define NFS
# endif /* not NFS */
# ifndef PCFS
#  define PCFS
# endif /* not PCFS */
# ifndef LOFS
#  define LOFS
# endif /* not LOFS */
# ifndef RFS
#  define RFS
# endif /* not RFS */
# ifndef MSDOSFS
#  define MSDOSFS
# endif /* not MSDOSFS */
# ifndef MFS
#  define MFS
# endif /* not MFS */
# ifndef CD9660
#  define CD9660
# endif /* not CD9660 */
# ifndef NFS
#  define NFS
# endif /* not NFS */
# include <sys/mount.h>
#endif /* HAVE_SYS_MOUNT_H */

/*
 * Actions to take if <netconfig.h> exists.
 */
#ifdef HAVE_NETCONFIG_H
# include <netconfig.h>
/* Some systems (Solaris 2.5.1) don't declare this external */
extern char *nc_sperror(void);
#endif /* HAVE_NETCONFIG_H */

/*
 * Actions to take if <sys/netconfig.h> exists.
 */
#ifdef HAVE_SYS_NETCONFIG_H
# include <sys/netconfig.h>
#endif /* HAVE_SYS_NETCONFIG_H */

/*
 * Actions to take if <sys/pathconf.h> exists.
 */
#ifdef HAVE_SYS_PATHCONF_H
# include <sys/pathconf.h>
#endif /* HAVE_SYS_PATHCONF_H */

/*
 * Actions to take if <sys/proc.h> exists.
 */
#ifdef HAVE_SYS_PROC_H
# include <sys/proc.h>
#endif /* HAVE_SYS_PROC_H */

/*
 * Actions to take if <sys/ucred.h> exists.
 */
#ifdef HAVE_SYS_UCRED_H
# include <sys/ucred.h>
#endif /* HAVE_SYS_UCRED_H */

/*
 * Actions to take if <sys/resource.h> exists.
 */
#ifdef HAVE_SYS_RESOURCE_H
# include <sys/resource.h>
#endif /* HAVE_SYS_RESOURCE_H */

/*
 * Actions to take if <sys/sema.h> exists.
 */
#ifdef HAVE_SYS_SEMA_H
# include <sys/sema.h>
#endif /* HAVE_SYS_SEMA_H */

/*
 * Actions to take if <sys/signal.h> exists.
 */
#ifdef HAVE_SYS_SIGNAL_H
# include <sys/signal.h>
#endif /* HAVE_SYS_SIGNAL_H */

/*
 * Actions to take if <sys/sockio.h> exists.
 */
#ifdef HAVE_SYS_SOCKIO_H
# include <sys/sockio.h>
#endif /* HAVE_SYS_SOCKIO_H */

/*
 * Actions to take if <sys/syscall.h> exists.
 */
#ifdef HAVE_SYS_SYSCALL_H
# include <sys/syscall.h>
#endif /* HAVE_SYS_SYSCALL_H */

/*
 * Actions to take if <sys/syslimits.h> exists.
 */
#ifdef HAVE_SYS_SYSLIMITS_H
# include <sys/syslimits.h>
#endif /* HAVE_SYS_SYSLIMITS_H */

/*
 * Actions to take if <tiuser.h> exists.
 */
#ifdef HAVE_TIUSER_H
# include <tiuser.h>
#endif /* HAVE_TIUSER_H */

/*
 * Actions to take if <sys/tiuser.h> exists.
 */
#ifdef HAVE_SYS_TIUSER_H
# include <sys/tiuser.h>
#endif /* HAVE_SYS_TIUSER_H */

/*
 * Actions to take if <sys/vfs.h> exists.
 */
#ifdef HAVE_SYS_VFS_H
# include <sys/vfs.h>
#endif /* HAVE_SYS_VFS_H */

/*
 * Actions to take if <sys/vmount.h> exists.
 */
#ifdef HAVE_SYS_VMOUNT_H
# include <sys/vmount.h>
#endif /* HAVE_SYS_VMOUNT_H */

/*
 * Actions to take if <ufs/ufs_mount.h> exists.
 */
#ifdef HAVE_UFS_UFS_MOUNT_H
# include <ufs/ufs_mount.h>
#endif /* HAVE_UFS_UFS_MOUNT_H */

/*
 * Are S_ISDIR, S_ISREG, et al broken?  If not, include <sys/stat.h>.
 */
#ifndef STAT_MACROS_BROKEN
# ifdef HAVE_SYS_STAT_H
#  include <sys/stat.h>
# endif /* HAVE_SYS_STAT_H */
#endif /* not STAT_MACROS_BROKEN */

/*
 * Actions to take if <stdio.h> exists.
 */
#ifdef HAVE_STDIO_H
# include <stdio.h>
#endif /* HAVE_STDIO_H */

/*
 * Actions to take if <stdlib.h> exists.
 */
#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif /* HAVE_STDLIB_H */

/*
 * Actions to take if <regex.h> exists.
 */
#ifdef HAVE_REGEX_H
# include <regex.h>
#endif /* HAVE_REGEX_H */


/****************************************************************************/
/*
 * Specific macros we're looking for.
 */
#ifndef HAVE_MEMSET
# ifdef HAVE_BZERO
#  define	memset(ptr, val, len)	bzero((ptr), (len))
# else /* not HAVE_BZERO */
#  error Cannot find either memset or bzero!
# endif /* not HAVE_BZERO */
#endif /* not HAVE_MEMSET */

#ifndef HAVE_MEMMOVE
# ifdef HAVE_BCOPY
#  define	memmove(to, from, len)	bcopy((from), (to), (len))
# else /* not HAVE_BCOPY */
#  error Cannot find either memmove or bcopy!
# endif /* not HAVE_BCOPY */
#endif /* not HAVE_MEMMOVE */

#ifndef HAVE_MEMCMP
# ifdef HAVE_BCMP
#  define	memcmp(a, b, len)	bcmp((a), (b), (len))
# else /* not HAVE_BCMP */
#  error Cannot find either memcmp or bcmp!
# endif /* not HAVE_BCMP */
#endif /* not HAVE_MEMCMP */

/*
 * Define type of mntent_t.
 * Defaults to struct mntent, else struct mnttab.  If neither is found, and
 * the operating system does keep not mount tables in the kernel, then flag
 * it as an error.  If neither is found and the OS keeps mount tables in the
 * kernel, then define our own version of mntent; it will be needed for amd
 * to keep its own internal version of the mount tables.
 */
#ifdef HAVE_STRUCT_MNTENT
typedef struct mntent mntent_t;
#else /* not HAVE_STRUCT_MNTENT */
# ifdef HAVE_STRUCT_MNTTAB
typedef struct mnttab mntent_t;
# else /* not HAVE_STRUCT_MNTTAB */
#  ifdef MOUNT_TABLE_ON_FILE
#   error Could not find definition for struct mntent or struct mnttab!
#  else /* not MOUNT_TABLE_ON_FILE */
typedef struct _am_mntent {
  char	*mnt_fsname;		/* name of mounted file system */
  char	*mnt_dir;		/* file system path prefix */
  char	*mnt_type;		/* MNTTYPE_* */
  char	*mnt_opts;		/* MNTOPT* */
  int	mnt_freq;		/* dump frequency, in days */
  int	mnt_passno;		/* pass number on parallel fsck */
} mntent_t;
#  endif /* not MOUNT_TABLE_ON_FILE */
# endif /* not HAVE_STRUCT_MNTTAB */
#endif /* not HAVE_STRUCT_MNTENT */

/*
 * Figure out if signal handlers have to be reinstated within
 * the signal handler (older SVR3 and V7 systems used to turn off the
 * handler once the signal was triggered).
 */
#if defined(SVR3) || defined(SVR4) || defined(__SVR4) || defined(__svr4__)
# if defined(HAVE_SIGNAL) && defined(HAVE_SIGNAL_H)
#  define REINSTATE_SIGNAL_HANDLER
# else /* not defined(HAVE_SIGNAL) && defined(HAVE_SIGNAL_H) */
#  error do not know how to restart SYS5 signals!
# endif /* not defined(HAVE_SIGNAL) && defined(HAVE_SIGNAL_H) */
#endif /* defined(SVR3) || defined(SVR4) || defined(__SVR4) || defined(__svr4__) */

/****************************************************************************/

/*
 * Existence of external definitions.
 */

/* does sys_errlist[] exist? */
#undef HAVE_EXTERN_SYS_ERRLIST

/* does optarg exist? */
#undef HAVE_EXTERN_OPTARG

/* does get_myaddress() exist? */
#undef HAVE_EXTERN_GET_MYADDRESS

/* does getdomainname() exist? */
#undef HAVE_EXTERN_GETDOMAINNAME

/* does gethostname() exist? */
#undef HAVE_EXTERN_GETHOSTNAME

/* does gettablesize() exist? */
#undef HAVE_EXTERN_GETTABLESIZE

/* does getpagesize() exist? */
#undef HAVE_EXTERN_GETPAGESIZE

/* does sbrk() exist? */
#undef HAVE_EXTERN_SBRK

/* does strdup() exist? */
#undef HAVE_EXTERN_STRDUP

/* does usleep() exist? */
#undef HAVE_EXTERN_USLEEP

/* does wait3() exist? */
#undef HAVE_EXTERN_WAIT3



/*
 * Complete external definitions missing from some systems.
 */

#ifndef HAVE_EXTERN_SYS_ERRLIST
extern const char * const sys_errlist[];
#endif /* not HAVE_EXTERN_SYS_ERRLIST */

#ifndef HAVE_EXTERN_OPTARG
extern char *optarg;
extern int optind;
#endif /* not HAVE_EXTERN_OPTARG */

#if defined(HAVE_GET_MYADDRESS) && !defined(HAVE_EXTERN_GET_MYADDRESS)
extern void get_myaddress(struct sockaddr_in *addr);
#endif /* defined(HAVE_GET_MYADDRESS) && !defined(HAVE_EXTERN_GET_MYADDRESS) */

#if defined(HAVE_GETDOMAINNAME) && !defined(HAVE_EXTERN_GETDOMAINNAME)
# if defined(HAVE_MAP_NIS) || defined(HAVE_MAP_NISPLUS)
extern int getdomainname(char *name, int namelen);
# endif /* defined(HAVE_MAP_NIS) || defined(HAVE_MAP_NISPLUS) */
#endif /* defined(HAVE_GETDOMAINNAME) && !defined(HAVE_EXTERN_GETDOMAINNAME) */

#if defined(HAVE_GETDTABLESIZE) && !defined(HAVE_EXTERN_GETDTABLESIZE)
extern int getdtablesize(void);
#endif /* defined(HAVE_GETDTABLESIZE) && !defined(HAVE_EXTERN_GETDTABLESIZE) */

#if defined(HAVE_GETHOSTNAME) && !defined(HAVE_EXTERN_GETHOSTNAME)
extern int gethostname(char *name, int namelen);
#endif /* defined(HAVE_GETHOSTNAME) && !defined(HAVE_EXTERN_GETHOSTNAME) */

#if defined(HAVE_GETPAGESIZE) && !defined(HAVE_EXTERN_GETPAGESIZE)
extern int getpagesize(void);
#endif /* defined(HAVE_GETPAGESIZE) && !defined(HAVE_EXTERN_GETPAGESIZE) */

#ifndef HAVE_EXTERN_SBRK
extern caddr_t sbrk(int incr);
#endif /* not HAVE_EXTERN_SBRK */

#if defined(HAVE_STRDUP) && !defined(HAVE_EXTERN_STRDUP)
extern char *strdup(const char *s);
#endif /* defined(HAVE_STRDUP) && !defined(HAVE_EXTERN_STRDUP) */

#if defined(HAVE_USLEEP) && !defined(HAVE_EXTERN_USLEEP)
extern int usleep(unsigned int useconds);
#endif /* defined(HAVE_USLEEP) && !defined(HAVE_EXTERN_USLEEP) */

#if defined(HAVE_WAIT3) && !defined(HAVE_EXTERN_WAIT3)
extern int wait3(int *statusp, int options, struct rusage *rusage);
#endif /* defined(HAVE_WAIT3) && !defined(HAVE_EXTERN_WAIT3) */



/****************************************************************************/
/*
 * amd-specific header files.
 */
#ifdef THIS_HEADER_FILE_IS_INCLUDED_ABOVE
# include <nfs_prot.h>
#endif /* THIS_HEADER_FILE_IS_INCLUDED_ABOVE */
#include <am_utils.h>
#include <amq_defs.h>
#include <aux_conf.h>
/* compatibilty with old amd, while autoconfistating it */
#include <am_compat.h>


/****************************************************************************/
/*
 * External defintions that depend on other macros available (or not)
 * and those are probably declared in any of the above headers.
 */

#ifndef HAVE_CLNT_SPERRNO
extern char *clnt_sperrno(enum clnt_stat stat);
#endif /* not HAVE_CLNT_SPERRNO */

#ifndef HAVE_HASMNTOPT
extern char *hasmntopt(mntent_t *mnt, char *opt);
#endif /* not HAVE_HASMNTOPT */

#ifndef HAVE_STRDUP
extern char *strdup(const char *s);
#endif /* not HAVE_STRDUP */

#ifndef HAVE_XDR_FTYPE
extern bool_t xdr_ftype(XDR *xdrs, ftype *objp);
#endif /* not HAVE_XDR_FTYPE */

#ifndef HAVE_XDR_NFSSTAT
extern bool_t xdr_nfsstat(XDR *xdrs, nfsstat *objp);
#endif /* not HAVE_XDR_NFSSTAT */

#ifndef HAVE_XDR_POINTER
extern bool_t xdr_pointer(register XDR *xdrs, char **objpp, u_int obj_size, xdrproc_t xdr_obj);
#endif /* not HAVE_XDR_POINTER */


#endif /* not _CONFIG_H */

/*
 * Local Variables:
 * mode: c
 * End:
 */

/* End of am-utils-6.x config.h file */
